
///////////////////////////////////////////////////////////////////////////////////////////////////////////
float winkelG,winkelG1,winkelG2;
float a, b;
float d,h;
float K;
float[][] Ergebnis;
float Frequenzen[];
float Amplituden[];
float winkelBM = 0;
float winkelBM1= 0;
float winkelBM2= 0;
float farbton1, farbton2, farbton3;
float x, y, X, Y;
float u, v, U, V;
float q, r, Q, R;
float s, t, S, T;
float umdrehungen;
float delta;
float deltaLinie;
boolean wahlB,wahlC,wahlD,wahlE,wahlF,wahlG;
boolean wahlH,wahlI,wahl1,wahl2,wahl3;
boolean nurEineKurveZeichnen;
boolean stopp;
//für eigene Farbpalette
boolean bunt=true;//Farbpalette Variation Hue oder eigen
boolean hS = true; //Hintergrund schwarz
boolean hintergrundFestgelegt = false;
int abschnitte =64;
int grenze = abschnitte+1;
color[] farbAnker; 
color[] farben4096;
float h1,s1,b1;
float h2,b2;
float H; 
int tastenH = 50;
int anzahlT;
boolean[] tasteAktiv;
boolean tastenWechsel=true;
char[] tBeschriftung;
PFont font;

////////////////////////////////////////////////////////////////// 
void setup() {
  size(800, 800);
  background(0);//weil bunt=true zu Beginn 
  colorMode(HSB, 360);
  smooth();
  winkelG =0;//mehrere Kurven mit Strecken dazwischen
  winkelG1=0;//eine Kurve
  delta = 0.08;
  deltaLinie = 0.5;
  Ergebnis = new float[4][2];
  for(int i=0; i<4;i++){
    for(int j=0; j<2;j++){
       Ergebnis[i][j]=0;
    }   
  } 
  Frequenzen = new float[8];  
  Amplituden = new float[8];
  //Standard-Wahl für Frequenzen und Amplituden:
  Frequenzen[0] = 2; Frequenzen[1]=3;
  Amplituden[0] = 300; Amplituden[1]=200; 
  Frequenzen[2] = 0; Frequenzen[3]=0;
  Amplituden[5] = 250; Amplituden[4]=300; 
  Frequenzen[4] = 3; Frequenzen[5]=5;
  Amplituden[2] = 200; Amplituden[3]=250;
  Frequenzen[6] = 5; Frequenzen[7]=7;
  K=1; //bestimmt die Frequenz der Modulation
  umdrehungen=1.5;
  winkelBM = radians(winkelG); 
  wahl1= true;
  wahlC= false;wahlD= false;wahlE=false;
  wahlF= false;wahlG= false;wahlH=false;
  wahlI= false;wahlB= false;
  
  if(wahl1 || wahl2 || wahl3) nurEineKurveZeichnen = true;
  else nurEineKurveZeichnen = false; 
  stopp=true; 
  farbton1 = 0;
  farbton2 = 120;
  farbton3 = 240;
  //für eigene Farbpalette
  farbAnker = new color[grenze];//Initialsierung
  for(int i=0;i<grenze;i++){
     farbAnker[i] = color(0);
  }
  
  farben4096 = new color[4096];
  for(int i=0;i<4096;i++){
     farben4096[i] = color(0);
  }
  
  farbPaletteBestimmen();
   tastenEinstellungen();

}
//////////////////////////////////////////////////////////////////////////

void draw() {
   tastenZeichnen(); 
  if(hS==true && !hintergrundFestgelegt){
    background(0);
    hintergrundFestgelegt = true;
  }
  if(hS==false && !hintergrundFestgelegt){
    background(360);
    hintergrundFestgelegt = true;
  }
  if(!stopp){
  translate(width/2, height/2);
  rotate(-PI/2);
 
  winkelBM  = radians(winkelG); 
  winkelBM1 = radians(winkelG1);
  winkelBM2 = radians(winkelG1+deltaLinie); 
 
  //zwischen zwei Kurven:  Kurven1 und Kurven3 mit fest gewählten Amplituden und Frequenzen
  if(wahlB){  
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1]);
     u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     s=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[2],Frequenzen[3],2)[0];
     t=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[2],Frequenzen[3],2)[1];
     strokeWeight(3);
     point(u,v); point(s,t);
     strokeWeight(1);
     line(u,v,s,t);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }  
  //zwischen zwei verschiedenen Kurven1 /////////////////////////////////////////////////////////////
  if(wahlC ){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     q=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     r=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     Q=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     R=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];    
     strokeWeight(2);
     point(q,r); point(Q,R);
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],100);
     strokeWeight(1);
     line(q,r,Q,R);    
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  //zwischen zwei verschiedenen Kurven2 ////////////////////////////////////////////////////////
  if(wahlD){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     x=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[0],Frequenzen[1],0)[0];
     y=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[0],Frequenzen[1],0)[1];
     X=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
     Y=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(x,y); point(X,Y);
     strokeWeight(1);
     line(x,y,X,Y);     
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }  
  //zwischen zwei verschiedenen Kurven3 //////////////////////////////////////////////////
  if(wahlE){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     s=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[0],Frequenzen[1],0)[0];
     t=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[0],Frequenzen[1],0)[1];
     S=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[2],Frequenzen[3],1)[0];
     T=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(s,t); point(S,T);
     strokeWeight(1);
     line(s,t,S,T);    
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1= (farbton1 +1)%4096;
  }
  //zwischen Kurven1, Kurven2 und Kurven3///////////////////////////////////////////////////////////////
  if(wahlF){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
     
     if(bunt)stroke(farbton2,360,360,50);
     else stroke(farben4096[(int)farbton2],50);
     x=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[4],Frequenzen[5],2)[0];
     y=kurve2(winkelBM,Amplituden[2],Amplituden[3],Frequenzen[4],Frequenzen[5],2)[1];
     X=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[2],Frequenzen[3],1)[0];
     Y=kurve3(winkelBM,Amplituden[4],Amplituden[5],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(x,y); point(X,Y);
     strokeWeight(1);
     line(x,y,X,Y); 
     if(bunt)farbton2 = (farbton2 +1)%360;
     else farbton2= (farbton2 +1)%4096;
  }
   //zwischen vier verschiedenen Kurven1 /////////////////////////////////////////////////////////////
  if(wahlG ){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
     if(bunt)stroke(farbton2,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[0];
     v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[1];
     U=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V); 
     if(bunt)farbton2 = (farbton2 +1)%360;
     else farbton2= (farbton2 +1)%4096;
     //zwischen zwei versch. Kurven1 (3) und (4)
     if(bunt)stroke(farbton3,360,360,100);
     else stroke(farben4096[(int)farbton3],150);
     u=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[0];
     v=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[1];
     U=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[6],Frequenzen[7],3)[0];
     V=kurve1(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[6],Frequenzen[7],3)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V); 
     if(bunt)farbton3 = (farbton3 +1)%360;
     else farbton3= (farbton3 +1)%4096;  
  }
   //zwischen vier verschiedenen Kurven2 /////////////////////////////////////////////////////////////
  if(wahlH ){   
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096; 
     
     if(bunt)stroke(farbton2,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[0];
     v=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[1];
     U=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V); 
     if(bunt)farbton2 = (farbton2 +1)%360;
     else farbton2= (farbton2 +1)%4096;
     
     //zwischen zwei versch. Kurven1 (3) und (4)
     if(bunt)stroke(farbton3,360,360,100);
     else stroke(farben4096[(int)farbton3],150);
     u=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[0];
     v=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[1];
     U=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[6],Frequenzen[7],3)[0];
     V=kurve2(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[6],Frequenzen[7],3)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V); 
     if(bunt)farbton3 = (farbton3 +1)%360;
     else farbton3= (farbton3 +1)%4096;  
  }
   //zwischen vier verschiedenen Kurven3 /////////////////////////////////////////////////////////////
  if(wahlI ){
     if(bunt)stroke(farbton1,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
 
     if(bunt)stroke(farbton2,360,360,100);
     else stroke(farben4096[(int)farbton1],150);
     u=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[0];
     v=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[1];
     U=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[0];
     V=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[2],Frequenzen[3],1)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V); 
     if(bunt)farbton2 = (farbton2 +1)%360;
     else farbton2= (farbton2 +1)%4096;
    
     if(bunt)stroke(farbton3,360,360,100);
     else stroke(farben4096[(int)farbton3],150);
     u=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[0];
     v=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[4],Frequenzen[5],2)[1];
     U=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[6],Frequenzen[7],3)[0];
     V=kurve3(winkelBM,Amplituden[0],Amplituden[1],Frequenzen[6],Frequenzen[7],3)[1];
     strokeWeight(3);
     point(u,v); point(U,V);
     strokeWeight(1);
     line(u,v,U,V); 
     if(bunt)farbton3 = (farbton3 +1)%360;
     else farbton3= (farbton3 +1)%4096;  
  }
  if(wahl1){
     strokeWeight(4);
     if(bunt)stroke(farbton1,360,360,360);
     else stroke(farben4096[(int)farbton1],360); 
     u=kurve1(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve1(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve1(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     V=kurve1(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  if(wahl2){    
     strokeWeight(4);
     if(bunt)stroke(farbton1,360,360,360);
     else stroke(farben4096[(int)farbton1],360);
     u=kurve2(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve2(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve2(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     V=kurve2(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  if(wahl3){
     strokeWeight(4);
     if(bunt)stroke(farbton1,360,360,360);
     else stroke(farben4096[(int)farbton1],360);
     u=kurve3(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     v=kurve3(winkelBM1,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     U=kurve3(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[0];
     V=kurve3(winkelBM2,Amplituden[0],Amplituden[1],Frequenzen[0],Frequenzen[1],0)[1];
     line(u,v,U,V);
     if(bunt)farbton1 = (farbton1 +1)%360;
     else farbton1 = (farbton1 +1)%4096;
  }
  
  if(!nurEineKurveZeichnen)winkelG =winkelG+delta;  
  else winkelG1=winkelG1+deltaLinie;
 
 if (winkelG >=umdrehungen*360 || winkelG1 >=umdrehungen*360) { 
    stopp= true;    
  }
 }//end of if(!stopp)
}//end of draw

//Kurve1
float[] kurve1(float winkel, float a, float b, float f1, float f2, int k){ 
    U = a*sin(f1*winkel);
    V = b*sin(f2*winkel);   
    Ergebnis[k][0] = U;Ergebnis[k][1] = V;
    return Ergebnis[k];
}
//Kurve2
float[] kurve2(float winkel, float a, float b, float f1, float f2, int k){
    X = cos(winkel*K)*a*sin(f1*winkel);
    Y = cos(winkel*K)*b*sin(f2*winkel);
    Ergebnis[k][0] = X;Ergebnis[k][1] = Y;
    return Ergebnis[k];
}
//Kurve3
float[] kurve3(float winkel,float a, float b,  float f1, float f2, int k){  
  S = 50*cos(f1*winkel) + 1.4*b*cos(100*f1*winkel/a);
  T = 50*sin(f2*winkel) - 1.4*b*sin(100*f2*winkel/a);
  Ergebnis[k][0] = S;Ergebnis[k][1] = T;
  return Ergebnis[k];
}
//////////////////////////////////////////////////////////////////////
void mousePressed() { 
  if(mouseY < height-tastenH){
   winkelG=0;
     winkelG1=0;
     winkelBM = 0; 
     hintergrundFestgelegt = false;
     //Frequenzen festlegen
     for(int i=0;i<8;i++){
        Frequenzen[i] = round(random(2,17));
        //Benachbarte Frequenzenen werden verschieden gewählt
        if(i>0){
          while(Frequenzen[i] == Frequenzen[i-1]){
              Frequenzen[i] = round(random(2,17));
          }      
        }
    } 
    //Amplituden festlegen
    for(int i=0;i<6;i++){
        Amplituden[i] = round(random(200,300));
        //Benachbarte Amplitudenen müssen verschieden sein
        if(i>0){
          while(Amplituden[i] == Amplituden[i-1]){
              Amplituden[i] = round(random(200,300));
          }      
        }
     }
     println();
     println("Zufällige Wahl von Frequenzen und Amplituden");  
     println("Frequenzen: ");
     for(int i=0; i<8;i++){
       print(Frequenzen[i]+"  ");
     }
     println();
     println("Amplituden: ");
     for(int i=0; i<6;i++){
       print(Amplituden[i]+"  ");
     }
     stopp =false;
  }else{
     int ort = int(mouseX/(tastenH));println(ort);
       if(tastenWechsel){
          for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
          tastenWechsel = false;
       }
      switch(ort){
              
      
      case 0: //'1'  erstes Funktionspaar 
         tasteAktiv[0]=true;
         wahl1 = true;
         wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl2=wahl3=false; 
         hintergrundFestgelegt = false;    
         nurEineKurveZeichnen=true;
         winkelG  =0;
         winkelG1 =0;
         winkelBM = 0; 
         winkelBM1= 0;
         nurEineKurveZeichnen=true;
         stopp =false;
         bunt = true; //sieht schöner aus!
         println();
         println("Lissajous-Kurve");     
        
      break;
      
      case 1://'2'  zweites Funktionspaar
         tasteAktiv[1]=true;
         wahl2 = true;
         wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl3=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=true;
         winkelG  = 0;
         winkelG1 = 0;
         winkelBM = 0; 
         winkelBM1= 0;
         nurEineKurveZeichnen=true;
         stopp =false;
         bunt = true; 
         println();
         println("gedämpfte Lissajous-Kurve");     
      break;
      
      case 2://'3'  drittes Funktionspaar
         tasteAktiv[2]=true;
         wahl3 = true;
         wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=false; 
         hintergrundFestgelegt = false;
         nurEineKurveZeichnen=true;
         winkelG  =0;
         winkelG1 = 0;
         winkelBM = 0; 
         winkelBM1= 0;
         nurEineKurveZeichnen=true;
         stopp =false;
         bunt = true; 
         println();
         println("trigonometrische Kurve");     
      break;
      
      case 3://'x'  erste Frequenz erhöhen
         tasteAktiv[3]=true;
         hintergrundFestgelegt = false;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;  
         Frequenzen[0]=Frequenzen[0]+1;
         println();
         println("neue Frequenz 1: "+Frequenzen[0]+" alte Frequenzen: "+Frequenzen[1],Frequenzen[2],Frequenzen[3]); 
         stopp =false;
      break;
      
      case 4://'y' zweite Frequenz erhöhen
         tasteAktiv[4]=true;
         hintergrundFestgelegt = false;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;     
         Frequenzen[1]=Frequenzen[1]+1;
         println();
         println("neue Frequenz 2: "+Frequenzen[1]+" alte Frequenzen: "+Frequenzen[0],Frequenzen[2],Frequenzen[3]);   
         stopp =false;
      break;
      
      case 5://'K'   Modulationsfaktor erhöhen
         tasteAktiv[5]=true;
         wahl2 = true;
         wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=false; 
         wahlH=wahlI=wahl1=wahl3=false; 
         K=K+0.2;
         hintergrundFestgelegt = false;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0; 
         farbton1 =0;
         stopp =false;
         println();
         println("Lissajous-Kurven Modulation mit Frequenzfaktor K = "+K);     
      break;
      
     case 6://'u' Umdrehungen erhöhen
         tasteAktiv[6]=true;
         hintergrundFestgelegt = false;
         umdrehungen=umdrehungen+1;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0; 
         stopp =false;
         println();
         println("Anzahl der Umdrehungen: "+umdrehungen);          
      break;
      
    case 7://'b'  Farbpalette ändern
         tasteAktiv[7]=true;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;  
         hintergrundFestgelegt = false;
         bunt = !bunt; 
         if(!bunt){
           farbPaletteBestimmen();
         }else {
           farbton1 = 0;
           farbton2 = 120;
           farbton3 = 240;
         }
         println();
         println("Farbpalette geändert!");
         farbton1 =0;
         stopp =false;         
      break;
      
    case 8://'p'   Hintergrund schwarz/weiß
         tasteAktiv[8]=true;
         if (hS == true) hS =false;
         else hS=true;
         hintergrundFestgelegt = false;
         winkelG=0;
         winkelG1=0;
         winkelBM = 0;  
         farbton1 = 0;    
         println();
         println("Wechsel Hintergrundfarbe schwarz/weiß!");
         farbton1 =0;
         farbton2 = 120;
         farbton3 = 240;
         stopp =false; 
      break;
      
     case 9://'s'   stopp/fortfahren
         tasteAktiv[9]=true;
         if(stopp){
              stopp = false;
         }else stopp=true; 
      break;
      
      default:
        background(200);
        println("Keine Aktion");
        break;
      }
  }
}
///////////////////////////////////////////////////////////////////////////////
void tastenZeichnen(){
  colorMode(RGB,256);
  stroke(0,0,100);
  tastenWechsel=true;
  fill(0,0,100);
  rect(width/2,height-tastenH/2,width,tastenH);
  for(int i=0; i<anzahlT; i++){
      if(tasteAktiv[i])fill(color(255,255,0));
      else fill(color(255));     
      rect(tastenH/2 + i*tastenH,height-tastenH/2,40,40);
      fill(0);
      text(tBeschriftung[i],tastenH/2-8 + i*tastenH,height-tastenH/2+8);  
      fill(255);
      if(i<2)  text(int(Frequenzen[i]),width/2+130+i*tastenH ,height-tastenH/2+8);     
      if(i==2) text(umdrehungen,width/2+130+i*tastenH ,height-tastenH/2+8);   
      if(i==3 && wahl2) text(K,width/2+150+i*tastenH ,height-tastenH/2+8);   
  }   
   colorMode(HSB,360);
}
/////////////////////////////////////////////////////////////////////////
void tastenEinstellungen(){
   rectMode(CENTER);
   font = createFont("Arial",20);
   textSize(24);  
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
   String s = "123xyKubps";
   anzahlT = s.length();
   tasteAktiv = new boolean[anzahlT];
   tBeschriftung = new char[anzahlT];
   for(int i= 0; i<anzahlT; i++) tBeschriftung[i] = s.charAt(i);
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
}
/////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  if(key=='B'){   
     wahlB = true;
     wahlC=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen Kurven1 und Kurve3");     
  }  
  if(key=='C'){   
     wahlC = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;    
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen zwei Kurven1");     
  }
  if(key=='D'){   
     wahlD = true;
     wahlB=wahlC=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen zwei modulierten Lissajous-Kurven");     
  }
  if(key=='E'){   
     wahlE = true;
     wahlB=wahlC=wahlD=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen zwei beliebigen Kurven");     
  }
  if(key=='F'){   
     wahlF = true;
     wahlB=wahlC=wahlD=wahlE=wahlG=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen Kurven1, Kurven2 und Kurven3");     
  }
  if(key=='G'){   
     wahlG = true;
     wahlB=wahlC=wahlD=wahlE=wahlF=wahlH=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen vier Kurven1");     
  }
  if(key=='H'){   
     wahlH = true;
     wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=wahlI=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen vier Kurven2");     
  }
  if(key=='I'){   
     wahlI = true;
     wahlB=wahlC=wahlD=wahlE=wahlF=wahlG=wahlH=wahl1=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=false;
     winkelG=0;
     winkelBM = 0; 
     nurEineKurveZeichnen=false;
     stopp =false;
     println();
     println("Flächen zwischen vier Kurven3");     
  }
  if(key=='1'){   
     wahl1 = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl2=wahl3=false; 
     hintergrundFestgelegt = false;    
     nurEineKurveZeichnen=true;
     winkelG  =0;
     winkelG1 =0;
     winkelBM = 0; 
     winkelBM1= 0;
     nurEineKurveZeichnen=true;
     stopp =false;
     bunt = true; //sieht schöner aus!
     println();
     println("Lissajous-Kurve");     
  }
  if(key=='2'){   
     wahl2 = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl3=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=true;
     winkelG  = 0;
     winkelG1 = 0;
     winkelBM = 0; 
     winkelBM1= 0;
     nurEineKurveZeichnen=true;
     stopp =false;
     bunt = true; 
     println();
     println("gedämpfte Lissajous-Kurve");     
  }
  if(key=='3'){   
     wahl3 = true;
     wahlB=wahlD=wahlE=wahlF=wahlG=wahlH=wahlI=wahl1=wahl2=false; 
     hintergrundFestgelegt = false;
     nurEineKurveZeichnen=true;
     winkelG  =0;
     winkelG1 = 0;
     winkelBM = 0; 
     winkelBM1= 0;
     nurEineKurveZeichnen=true;
     stopp =false;
     bunt = true; 
     println();
     println("trigonometrische Kurve");     
  }
  if(key=='s'){   
     if(stopp){
       stopp = false;
    }else stopp=true; 
  }
  if(key=='a'){   
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;   
    //alle Amplituden verkleinern
     for(int i=0;i<6;i++){
        Amplituden[i] =Amplituden[i]/1.2;         
     }
     println();
     println("Amplituden: ");  
     for(int i=0; i<6;i++){
       print(Amplituden[i]+"  ");
     }
     delta = delta*1.2;
     stopp =false;  
  }
  if(key=='A'){   
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;   
    //alle Amplituden vergrößern
     for(int i=0;i<6;i++){
        Amplituden[i] =Amplituden[i]*1.2;         
     }
     println();
     println("Amplituden: ");  
     for(int i=0; i<6;i++){
       print(Amplituden[i]+"  ");
     }
     delta = delta/1.2;
     stopp =false;  
  }
  if(key=='k'){   
     if(wahlD==true || wahlF==true || wahl2==true){
       wahlB=wahlC=wahlE=wahlG=false; 
       wahlH=wahlI=wahl1=wahl3=false; 
       if(K>0.11)K=K-0.1;
       hintergrundFestgelegt = false;
       winkelG=0;
       winkelG1=0;
       winkelBM = 0; 
       farbton1 =0;
       stopp =false;
       println();
       println("Lissajous-Kurven Modulation mit Frequenzfaktor K = "+K);     
     }else {
       println();
       println(" Hat bei dieser Wahl keinen Einfluss, da der Modulationsfaktor K nur auf Kurve2 wirkt!");
     }
  }
  if(key=='K'){   
     wahl2 = true;
     wahlB=wahlC=wahlE=wahlF=wahlG=false; 
     wahlH=wahlI=wahl1=wahlD=wahl3=false; 
     K=K+0.2;
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0; 
     farbton1 =0;
     stopp =false;
     println();
     println("Lissajous-Kurven Modulation mit Frequenzfaktor K = "+K);     
  }
 if(key=='Z'){ //doppelte Punktezahl  
     hintergrundFestgelegt = false;
     delta = delta/2;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;    
     stopp =false;
     println();
     println("Doppelte Punktezahl: Winkel-Delta: "+delta);       
  } 
  if(key=='z'){ //halbe Punktezahl  
     hintergrundFestgelegt = false;
     delta = delta*2;    
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;      
     stopp =false;
     println();
     println("Halbe Punktezahl: Winkel-Delta: "+delta);       
  } 
  if(key=='u'){            
     hintergrundFestgelegt = false;
     umdrehungen=umdrehungen+1;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0; 
     stopp =false;
     println();
     println("Anzahl der Umdrehungen: "+umdrehungen);     
  }
  if(key=='x'){  
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;  
     Frequenzen[0]=Frequenzen[0]+1;
     println();
     println("neue Frequenz 1: "+Frequenzen[0]+" alte Frequenzen: "+Frequenzen[1],Frequenzen[2],Frequenzen[3]); 
     stopp =false;
    
  }
  if(key=='y'){ 
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;     
     Frequenzen[1]=Frequenzen[1]+1;
     println();
     println("neue Frequenz 2: "+Frequenzen[1]+" alte Frequenzen: "+Frequenzen[0],Frequenzen[2],Frequenzen[3]);   
     stopp =false;
  }
 
  if(key=='b'){ 
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;  
     hintergrundFestgelegt = false;
     bunt = !bunt; 
     if(!bunt){
       farbPaletteBestimmen();
     }else {
       farbton1 = 0;
       farbton2 = 120;
       farbton3 = 240;
     }
     println();
     println("Farbpalette geändert!");
     farbton1 =0;
     stopp =false;
   }
  if(key=='p'){ 
     if (hS == true) hS =false;
     else hS=true;
     hintergrundFestgelegt = false;
     winkelG=0;
     winkelG1=0;
     winkelBM = 0;  
     farbton1 = 0;    
     println();
     println("Wechsel Hintergrundfarbe schwarz/weiß!");
     farbton1 =0;
     farbton2 = 120;
     farbton3 = 240;
     stopp =false; 
  }
   
}
/////////////////////////////////////////////////////////////////////////////////////////////
void farbPaletteBestimmen(){
  h1=random(360);
  b1=random(360);
  s1=360;
  farbAnker[0] = color(h1,s1,b1);
 
  for(int j=1; j<grenze; j++){
      farbAnker[j] = farbeBestimmen( farbAnker[j-1]);  
  }
  for(int i=0; i<abschnitte; i++){
    zwischenFarbenBestimmen(i*abschnitte,farbAnker[i],farbAnker[i+1]);
  }
}
//für eigene Farbpalette
color farbeBestimmen(color f){
  color farbe = color(0);//Initialisierung
  h1=hue(f);
  h2=random(360);
  H = abs(h1-h2);
  b2=random(360);
  while(H>30){
    h2=random(360);
    H = abs(h1-h2);
  }
  farbe = color(h2,360,b2);
  return farbe;
}

void zwischenFarbenBestimmen(int k, color f1, color f2){
   int start = k;
   for(int i=start; i<64+start;i++){
      farben4096[i] = lerpColor(f1,f2,(float)(i-start)/64);
   }
}

void zufaelligeFreqenzenUndAmplituden(){
   for(int i=0;i<8;i++){
        Frequenzen[i] = round(random(2,23));
        //Benachbarte Frequenzenen werden verschieden gewählt
        if(i>0){
          while(Frequenzen[i] == Frequenzen[i-1]){
              Frequenzen[i] = round(random(2,23));
          }      
        }
    } 
    //Amplituden festlegen
    for(int i=0;i<6;i++){
        Amplituden[i] = round(random(200,300));
        //Benachbarte Amplitudenen müssen verschieden sein
        if(i>0){
          while(Amplituden[i] == Amplituden[i-1]){
              Amplituden[i] = round(random(200,300));
          }      
        }
     }
      println();
     println("Zufällige Wahl von Frequenzen und Amplituden");  
     println("Frequenzen: ");
     for(int i=0; i<8;i++){
       print(Frequenzen[i]+"  ");
     }
     println();
     println("Amplituden: ");
     for(int i=0; i<8;i++){
       print(Amplituden[i]+"  ");
     }
}
